t1 <- Sys.time()
cat("\014") 
options(max.print=1000000)

library(ggplot2)
library(ggthemes)
library(extrafont)
library(plyr)
library(scales)
library(reshape2)


dat <- read.table(text = "HTTP_4 Secret_2  Host.PID_1 Host.IPC_1 Docker.Sock_2   
Agree       1 1 1 1 2
Disagree    3 1 0 0 0", sep = "", header = TRUE)

datm <- melt(cbind(dat, ind = rownames(dat)), id.vars = c('ind'))

print(head(datm))

pdf('/Users/akondrahman/Documents/RESEARCH/KUBERNETES/SECURITY-WORK/REBUTTAL-ROUND-3/bug-report-perception.pdf', width=6, height=2.5)


the_plot <- ggplot(datm, aes(x = variable, y = value, fill = ind)) + geom_bar(position = "fill", stat = "identity", width = 0.35) 
the_plot <- the_plot + scale_y_continuous(labels = percent_format()) 
the_plot <- the_plot + theme(legend.title = element_blank(), 
                             text = element_text(size=10), 
                             axis.title.x = element_text(face='bold'), 
                             axis.title.y = element_text(face='bold'), 
                             legend.position="top", 
                             legend.direction="horizontal") 


the_plot <- the_plot + labs(x="Security Misconfiguration", y="Agreement Rate") 
the_plot <- the_plot + coord_flip() 
the_plot <- the_plot + scale_fill_manual(breaks = c(  "Agree", "Disagree" ),  values=c("forestgreen", "gold"))


the_plot

dev.off()

t2 <- Sys.time()
print(t2 - t1)  
rm(list = setdiff(ls(), lsf.str()))