cat("\014") 
options(max.print=1000000)
t1 <- Sys.time()

library(aod)
library(ggplot2)
library(car)
library(pscl)

# https://stats.oarc.ucla.edu/r/dae/logit-regression/ 

# GITHUB 
METRIC_FILE <- "/Users/akondrahman/Documents/RESEARCH/KUBERNETES/SECURITY-WORK/REBUTTAL-ROUND-3/REPLICATION/DATASET/GITHUB_METRICS.csv"

# # GITLAB 
# METRIC_FILE <- "/Users/akondrahman/Documents/RESEARCH/KUBERNETES/SECURITY-WORK/REBUTTAL-ROUND-3/REPLICATION/DATASET/GITLAB_METRICS.csv"

METRIC_DATA <- read.csv(METRIC_FILE)
METRIC_DATA <- METRIC_DATA[ -c(1  ) ]
METRIC_DATA$DEPLOY <- factor(METRIC_DATA$DEPLOY)
METRIC_DATA$INSECURE <- factor(METRIC_DATA$INSECURE)
print('=============================')
print(head( METRIC_DATA ))
print('=============================')
summary(METRIC_DATA)
print('=============================')
METRIC_DATA$SIZE <- log1p(METRIC_DATA$SIZE + 1 ) 
METRIC_DATA$AGE  <- log1p(METRIC_DATA$AGE + 1 ) 
METRIC_DATA$COMMITS <- log1p(METRIC_DATA$COMMITS + 1 ) 
METRIC_DATA$DEVS  <- log1p(METRIC_DATA$DEVS + 1 ) 
METRIC_DATA$MINORS  <- log1p(METRIC_DATA$MINORS + 1 ) 

theLogit <- glm(INSECURE ~ DEPLOY + SIZE + AGE + COMMITS + DEVS + MINORS , data = METRIC_DATA, family = "binomial")
summary(theLogit)
print('=============================')
vif( theLogit  )
# VIF: https://towardsdatascience.com/assumptions-of-logistic-regression-clearly-explained-44d85a22b290 
# Coefficient interpretation: https://statisticsbyjim.com/regression/interpret-coefficients-p-values-regression/
print('=============================')
pR2( theLogit  )
# we will use McFadden R-Squared : https://thestatsgeek.com/2014/02/08/r-squared-in-logistic-regression/ 
# https://www.r-bloggers.com/2015/09/how-to-perform-a-logistic-regression-in-r/
print('=============================')
anova( theLogit, type=2) 
# https://www.r-bloggers.com/2011/03/anova-%E2%80%93-type-iiiiii-ss-explained/

t2 <- Sys.time()
print(t2 - t1)  
rm(list = setdiff(ls(), lsf.str()))