### Replication Package for the Paper Titled **Security Misconfigurations in Open Source Kubernetes Manifests: An Empirical Study**


- CONTENT.md: Describes the content of the package. Also includes the link to the Docker image for ease of use by researchers and developers 
- URL to Docker image: https://hub.docker.com/repository/docker/akondrahman/sli-kube

- CODE: Contains all the source code needed for replication 
    - TOOL: Contains all the source code used to develop SLI-KUBE 
    - LOGIREG: Contains the source needed to generate R plots and perform logistic regression  
    - Queries.txt: Contains the queries used to mine the repositories 
    - INSTRUCT.md: Contains instructions on how to run the code and understand the output of the generated CSV files 

- DATASET: Contains all the datasets 
    - GITHUB-URLS.csv: Contains all the URLs for all 1590 manifests used in GitHub dataset  
    - GITLAB-URLS.csv: Contains all the URLs for all 449 manifests used in GitLab dataset  
    - BUG-REPORTS.xlsx: Contains all the URLs of the repositories 
    - SECDEV2020-ARTIFACTS.xlsx: Contains all the URLs of Internet Artifacts used in Shamim et al.'s paper 
    - GITHUB_METRICS.csv contains the metrics used for logistic regression for the GitHub dataset 
    - GITLAB_METRICS.csv contains the metrics used for logistic regression for the GitLab dataset 
    - GITHUB-FINAL-COUNT.csv contains the count of security misconfigurations for the 1,590 manifests mined from the GitHub dataset of 71 repositories 
    - GITLAB-FINAL-COUNT.csv contains the count of security misconfigurations for the 449 manifests mined from the GitLab dataset of 21 repositories 
    - DEPLOY-REPOS.csv provides the names of the repositories for the 71 GitHub repositories and 21 GitLab repositories that we consider deployable
    - INTERVIEW.txt contains interview protocol and interview excerpts 

